package jcg.zheng.demo;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;
import static org.junit.Assert.assertTrue;

import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import jcg.zheng.demo.data.User;

public class MapTestUtil {

	private static final int NOT_EXIST_KEY = 5;
	private static final int KEY_11 = 11;
	private static final String ABC = "ABC";
	private static final String DEFAULT_VALUE = "defaultValue";
	private static final String MARY_ZHENG = "Mary Zheng";
	private static final String ZHENG = "Zheng";
	private static final String MARY = "Mary";

	public void add4Elements(final Map<Integer, String> integerMap) {
		// no duplicate in a set
		integerMap.put(KEY_11, ABC);
		int mapSize = integerMap.size();
		integerMap.put(KEY_11, ABC);
		assertEquals(mapSize, integerMap.size());

		assertEquals(ABC, integerMap.get(KEY_11));
		assertTrue(integerMap.containsKey(KEY_11));
		assertTrue(integerMap.containsValue(ABC));

		assertNull(integerMap.get(NOT_EXIST_KEY));
		assertEquals(DEFAULT_VALUE, integerMap.getOrDefault(NOT_EXIST_KEY, DEFAULT_VALUE));

		integerMap.put(22, "JCG");
		integerMap.put(4, "123");
		integerMap.put(3, "XYZ");
	}

	public void removeElements(final Map<Integer, String> integerMap) {
		integerMap.remove(KEY_11);
		integerMap.replace(2, "JCG", MARY);

	}

	public void add4Users(final Map<User, String> userMap) {
		User user1 = new User(MARY, ZHENG, 15);
		userMap.put(user1, MARY_ZHENG);

		assertEquals(1, userMap.size());
		Set<User> keySet = userMap.keySet();

		Iterator<User> it = keySet.iterator();
		User key1 = it.next();
		assertTrue(user1.equals(key1));
		assertEquals(MARY_ZHENG, userMap.get(key1));

		assertEquals(MARY_ZHENG, userMap.get(user1));
		assertTrue(userMap.containsKey(user1));
		assertTrue(userMap.containsValue(MARY_ZHENG));
		assertEquals(MARY_ZHENG, userMap.get(user1));

		assertNull(userMap.get(new User("Tom", ZHENG, 25)));
		assertEquals(DEFAULT_VALUE, userMap.getOrDefault(new User("Tom", ZHENG, 25), DEFAULT_VALUE));

		userMap.put(new User("Eve", "Smith", 12), "Name1");
		userMap.put(new User("Adm", "Johnson", 22), "Name3");
		userMap.put(new User("Bob", "Zheng", 1), "Name4");
	}
}