package jcg.zheng.demo;

import static org.junit.Assert.assertEquals;

import java.util.Collections;
import java.util.Random;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class ThreadSafeTreeMapTest extends MapTestUtil {

	private static final int COUNT = 100;
	SortedMap<Integer, String> mapObj;
	Random randon = new Random();
	private ExecutorService executor;

	@Before
	public void setup() {
		executor = Executors.newFixedThreadPool(5);
	}

	@After
	public void finish() {
		try {
			executor.awaitTermination(10l, TimeUnit.SECONDS);
		} catch (Exception e) {
			// ignore
		}
		assertEquals(COUNT, mapObj.size());

	}

	@Test
	public void synchronizedSortedMap_test() {
		mapObj = Collections.synchronizedSortedMap(new TreeMap<Integer, String>());

		for (int i = 0; i < COUNT; i++) {
			executor.submit(this::addOne);
		}

	}

	public void addOne() {
		mapObj.put(randon.nextInt(), "Mary");
	}
}
